<div class="peer-connection">
  {#each participants as participantId (participantId)}
  <div class="participant">
  {#each tracks as track (track.id)}
    <!-- Gross, I know -->
    {#if getUserId(track.id) == participantId}
      <ParticipantTrack {track} />
    {/if}
  {/each}
  </div>
  {/each}
</div>

<script>
  export default {
    helpers: {
      getUserId(trackId) {
        return trackId.substring(0, trackId.indexOf("-"));
      }
    },
    data() {
      return {
        participants: [],
        tracks: []
      };
    },
    methods: {
      onTrack(event) {
        const {tracks} = this.get();
        tracks.push(event.track);
        event.track.onended = () => {
          const tracks = this.get().tracks;
          const index = tracks.indexOf(event.track);
          if (index !== -1) {
            tracks.splice(index, 1);
            this.set({tracks});
          }
        };
      }
    },
    onstate({current, changed, previous}) {
      if (changed.peerConnection) {
        if (previous.peerConnection) {
          previous.peerConnection.ontrack = undefined;
        }
        if (current.peerConnection) {
          current.peerConnection.ontrack = this.onTrack.bind(this);
        }
      }
    },
    components: {
      ParticipantTrack: "./ParticipantTrack.svelte"
    }
  };
</script>
